//+------------------------------------------------------------------+
//|                                                        Sigma.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_plots   3
#property indicator_minimum 0
//--- plot Sigma
#property indicator_label1  "Media"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
#property indicator_label2  "Scarto"
#property indicator_type2   DRAW_LINE
#property indicator_color2  clrYellow
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
#property indicator_label3  "MediaDw"
#property indicator_type3   DRAW_LINE
#property indicator_color3  clrGreen
#property indicator_style3  STYLE_SOLID
#property indicator_width3  1
/*
#property indicator_label4  "Sigma"
#property indicator_type4   DRAW_LINE
#property indicator_color4  clrRed
#property indicator_style4  STYLE_SOLID
#property indicator_width4  1
*/

extern int MAperiodo             = 20;
extern int price                 = 1;
//--- indicator buffers
double         Val_i[];
double         Media[];
double         ScartoMedio[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,Media);
   SetIndexBuffer(1,ScartoMedio);
   SetIndexBuffer(2,Val_i);
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   int i=Bars-prev_calculated-MAperiodo-1;
   Media[i+1]=0;
   ScartoMedio[i+1]=0;
   int n=0;
   while(i>=0){
   if(MAperiodo>1)
      Val_i[i]=MathAbs(MyPrice(i)-iMA(Symbol(),0,MAperiodo,0,MODE_SMA,PRICE_MEDIAN,i+1));
   else
      Val_i[i]=MathAbs(MyPrice(i)-((High[i+1]+Low[i+1])/2));
      
      Media[i]=(Media[i+1]*n+Val_i[i])/(n+1);
      double scarto_i=MathPow(Val_i[i]-Media[i],2);
      //ScartoMedio[i]=MathPow(scarto_i,0.5);
      ScartoMedio[i]=MathPow((MathPow(ScartoMedio[i+1],2)*n+scarto_i)/(n+1),0.5);
      n++;
      i--;
   }
   return(rates_total);
  }
  
  double MyPrice(int i){
      if(price==0)
         return(Close[i]);
      else if(price==1)
         return(Open[i]);
      else if(price==2)
         return(High[i]);
      else if(price==3)
         return(Low[i]);
      else if(price==4)
         return((High[i]+Low[i])/2);
      else return(0.0);
  }
//+------------------------------------------------------------------+
